#include <iostream>
using namespace std;

class Base {
  public:
    virtual void print() = 0;
};

class Derived1 : public Base {
  public:
};

class Derived2 : public Derived1 {
  public:
    void print();
};

// pure virtual
// void Base::print() {
//   cout << "Base class" << endl;
// }

// not overridden in Derived1
// void Derived1::print() {
//  cout << "Derived1 class" << endl;
// }

void Derived2::print() {
  cout << "Derived2 class" << endl;
}

int main() {
  Base *ptr = new Base();
  Base *ptr1 = new Derived1();
  Base *ptr2 = new Derived2();

  ptr->print();  
  ptr1->print(); 
  ptr2->print(); 

  return 0;
}


