#include <iostream>
using namespace std;

class Base {
  public:
    virtual void print();
};

class Derived1 : public Base {
  public:
    void print();
};

class Derived2 : public Derived1 {
  public:
    void print();
};

void Base::print() {
   cout << "Base class" << endl;
}

void Derived1::print() {
  Derived2::print();
}

void Derived2::print() {
  cout << "Derived2 class" << endl;
}

int main() {
  Base *ptr = new Base();
  Base *ptr1 = new Derived1();
  Base *ptr2 = new Derived2();

  ptr->print();  
  ptr1->print(); 
  ptr2->print(); 

  return 0;
}


