#include <iostream>
using namespace std;

class Base {
  public:
    void hello();
    virtual void print();
};

class Derived1 : public Base {
  public:
    void print();
};

class Derived2 : public Derived1 {
  public:
    void print();
};

void Base::print() {
   cout << "Base class" << endl;
}

void Base::hello() {
   cout << "Hello" << endl;
}

void Derived1::print() {
  cout << "Derived1 class" << endl;
}

void Derived2::print() {
  cout << "Derived2 class" << endl;
}

int main() {
  Base *ptr = new Base();
  Base *ptr1 = new Derived1();
  Base *ptr2 = new Derived2();

  ptr->print();  
  ptr1->print(); 
  ptr2->print(); 

  Derived2 *d2ptr = new Derived2();
  d2ptr->hello(); 

  return 0;
}


