#include <iostream>
using namespace std;

class Base {
  public:
    void print();
};

class Derived1 : public Base {
  public:
};

class Derived2 : public Derived1 {
  public:
    void print();
};

void Base::print() {
  cout << "Base class" << endl;
}

// void Derived1::print() {
//  cout << "Derived1 class" << endl;
// }

void Derived2::print() {
  cout << "Derived2 class" << endl;
}

int main() {
  Base *ptr = new Base();
  Base *ptr1 = new Derived1();
  Base *ptr2 = new Derived2();

  ptr->print();  // "Base" 
  ptr1->print(); // "Base" 
  ptr2->print(); // "Base" 

  Derived1 *d1ptr = new Derived1();
  Derived1 *d1ptr2 = new Derived2();
  Derived2 *d2ptr = new Derived2();
  cout << endl << endl;

  d1ptr->print();  // "Base" no implementation in D1 
  d1ptr2->print(); // "Base" non-virtual in D1 
  d2ptr->print();  // "Derived2" 

  return 0;
}


